using System;

class Program
{
    static void Main()
    {
        string[] s1 = Console.ReadLine().Split();
        int n = int.Parse(s1[0]);
        int q = int.Parse(s1[1]);

        long[] di = new long[n];
        long[] pi = new long[n];

        for (int i = 0; i < n; i++)
        {
            string[] s2 = Console.ReadLine().Split();
            di[i] = long.Parse(s2[0]);
            pi[i] = long.Parse(s2[1]);
        }

        long[] k = new long[q];
        for (int i = 0; i < q; i++)
        {
            k[i] = long.Parse(Console.ReadLine());
        }

        long[] sKupljeno = new long[n];
        long[] sPojedeno = new long[n];

        sKupljeno[0] = pi[0];
        sPojedeno[0] = Math.Min(di[0] - 1, pi[0]);

        for (int i = 1; i < n; i++)
        {
            long razlikaDana = di[i] - di[i - 1] + 1;
            long dostupno = sKupljeno[i - 1] - sPojedeno[i - 1];
            long pojedenoTr = Math.Min(dostupno, razlikaDana);

            sPojedeno[i] = sPojedeno[i - 1] + pojedenoTr;
            sKupljeno[i] = sKupljeno[i - 1] + pi[i];
        }

        long[] rez = new long[q];

        for (int i = 0; i < q; i++)
        {
            long kraj = k[i];
            int trdan = 0;

            while (trdan < n && di[trdan] <= kraj)
            {
                trdan++;
            }

            long razlikaDana = 0;
            if (trdan == 0)
            {
                razlikaDana = kraj;
            }
            else
            {
                razlikaDana = kraj - di[trdan - 1] + 1;
            }

            long dostupno = 0;
            if (trdan > 0)
            {
                dostupno = sKupljeno[trdan - 1] - sPojedeno[trdan - 1];
            }

            long pojedenoDoSada = Math.Min(dostupno, razlikaDana);

            if (trdan > 0)
            {
                rez[i] = sPojedeno[trdan - 1] + pojedenoDoSada;
            }
            else
            {
                rez[i] = pojedenoDoSada;
            }
        }

        for (int i = 0; i < q; i++)
        {
            Console.WriteLine(rez[i]);
        }
    }
}